/* <St> *******************************************************************

   sourcesink.c 
  
  -------------------------------------------------------------------------
  CREATETED     : D. Tsaava,  Hilscher GmbH
  DATE          : 28.01.2005
  PROJEKT       : tcp-ip server for the Linux CIF Device Driver
  =========================================================================

  DISCRIPTION
    sink routine               .
  =========================================================================

  CHANGES
  version name      date        Discription
  V1.003      11/08       Missing varaiable fixed

  V1.002      07/08       Function sink changed
													// 07.07.2008 Input buffer handling now processed, as long as datas in the buffer
													//            Maybe a TCP/IP frame holds two "RCS Messages"

                 
  V1.001	    01/05       RCS messages are sent now to the client
		                considering the real data length in it
                                i.e. client gets message header lenght + 
                                                 dala.len
                                usBoard is now defined extern
-------------------------------------------------------------------------
  V1.001

  ======================== Copyright =====================================

  Copyright (C) 2004  Hilscher GmbH

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
   
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

  ========================================================================
******************************************************************** <En> */
#include <ctype.h>
#include "SOCKET.h"
#include "ODMTCP.h"

extern int fdrvConn;
extern unsigned short usBoard;

int iMsgPartLen = 0;
unsigned char  abContiguousMsgBuffer[1312]; /* readlen + 288 = 1024 + 288 = 1312 */

void  copy_board_struct( unsigned char* pabGenBoardsInfo32, unsigned char* pabBoardsInfo)
{
  short               sRet  = DRV_NO_ERROR;
  unsigned int        uiTmp = 0x64646464; // value invalid, 1st used for ulPhysAddr, indicate 64-bit address only!
  unsigned short      usCnt = 0, usByteOff = 0;
  BOARD_INFOEX*       pBoardsInfo   = (BOARD_INFOEX *)pabBoardsInfo;
  GENERAL_BOARD_INFO* pBoardsInfo32 = (GENERAL_BOARD_INFO *)pabGenBoardsInfo32;

  for( usCnt = 0; usCnt < MAX_DEV_BOARDS; usCnt++) { 
    sRet = DevInitBoard( usCnt); 
    pBoardsInfo32->sErrorNumber[usCnt] = sRet;  // save error
    if( DRV_NO_ERROR == sRet) {
	memcpy( (unsigned char *)&(pBoardsInfo32->tBoardInfo.abDriverVersion),
		(unsigned char *)&(pBoardsInfo->abDriverVersion),
		16);
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&pBoardsInfo->tBoard[usCnt].usBoard,
		2);
        usByteOff += 2;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&pBoardsInfo->tBoard[usCnt].usAvailable,
		2);
        usByteOff += 2;
	memcpy( (unsigned int *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&pBoardsInfo->tBoard[usCnt].usIrq,
		2);
        usByteOff += 2;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.ulOpenCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.CloseCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.ulReadCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.ulWriteCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.ulIRQCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		(unsigned char *)&pBoardsInfo->tBoard[usCnt].tDriverInfo.bInitMsgFlag,
		9);
        usByteOff += 9;
        uiTmp = (unsigned int)pBoardsInfo->tBoard[usCnt].tDriverInfo.ulExIOCnt;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		&uiTmp,
		4);
        usByteOff += 4;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		(unsigned char *)&(pBoardsInfo->tBoard[usCnt].tFirmware),
		32); //sizeof( FIRMWAREINFO));
        usByteOff += 32;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		(unsigned char *)&(pBoardsInfo->tBoard[usCnt].tDeviceInfo),
		6); //sizeof( FIRMWAREINFO));
        usByteOff += 6;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		(unsigned char *)&(pBoardsInfo->tBoard[usCnt].tRcsInfo),
		8); //sizeof( FIRMWAREINFO));
        usByteOff += 8;
	memcpy( (unsigned short *)&(pBoardsInfo32->tBoardInfo.abCatchall[usByteOff]),
		(unsigned char *)&(pBoardsInfo->tBoard[usCnt].tVersion),
		32); //sizeof( FIRMWAREINFO));
        usByteOff += 32;
    }
    sRet = DevExitBoard( usCnt);
  }
}

void
sink(int sockfd)
{
  int	byteLen = 0, byteLen32 = 0;
  int iBytesReceived = 0;
  int iWriteLength   = 0, iLengthWritten  = 0;

  short               sRet = DRV_NO_ERROR;
  GENERAL_BOARD_INFO  tGenBoardsInfo32;
  BOARD_INFOEX        tBoardsInfoEx;
  MSG_STRUC           tMessage;

  if( pauseinit)
    sleep( pauseinit);

  /* Open the driver */
  if( (sRet = DevOpenDriver() ) != DRV_NO_ERROR) {
    fdrvConn = 0;
    DBG_PRN( "DevOpenDriver(): Ret = %5d \n", sRet );
  } else 	
    fdrvConn = 1;

  for( ; ; ) {
    if( (iBytesReceived = read(sockfd, rbuf, readlen)) < 0) { 
      err_sys("read error");  
    } else if (iBytesReceived == 0) {
      break; /* connection closed by peer */
		} else { //if (n != readlen) {
      // NEW: Check if we have still data left in the buffer
      unsigned char*  inBuffer;// = &rbuf[0];
			if( iMsgPartLen != 0) {
        DBG_PRN( "previous msg part len = %d \n", iMsgPartLen );
				memcpy( &abContiguousMsgBuffer[iMsgPartLen], &rbuf[0], iBytesReceived);
				inBuffer = &abContiguousMsgBuffer[0];
				iBytesReceived = iBytesReceived + iMsgPartLen;
			  iMsgPartLen = 0;
			} else {
				inBuffer = &rbuf[0];
			}

      DBG_PRN("read returned %d, start: %.2X%.2X%.2X%.2X%.2X\n", iBytesReceived, 
                                                                 inBuffer[0], inBuffer[1], inBuffer[2], inBuffer[3], inBuffer[4]);
      while( iBytesReceived > 0) {
        // NEW: Check if we have a ODM select or RCS message
        if( memcmp( inBuffer, "ODM", 3) == 0) {
          switch( inBuffer[3]) {
            case BOARD_SELECT_COMMAND:  // client requested BoardInfo
	            memcpy( &wbuf[0], "ODM", 3);
	            wbuf[3] = BOARD_SELECT_ANSWER;
	            byteLen = sizeof( BOARD_INFOEX);
	            memset( (unsigned char *)&tBoardsInfoEx, 0x00, byteLen);
              if( (sRet = DevGetBoardInfoEx( &tBoardsInfoEx )) != DRV_NO_ERROR) {
                DBG_PRN( "DevGetBoardInfoEx()       RetWert = %5d \n", sRet );
              } else {
	              memset( (unsigned char *)&tGenBoardsInfo32, 0x00, byteLen);
	              copy_board_struct( (unsigned char *)&tGenBoardsInfo32, (unsigned char *)&tBoardsInfoEx);
                                    byteLen32 = sizeof( GENERAL_BOARD_INFO);
	              memcpy( &wbuf[4], (unsigned char *)&tGenBoardsInfo32, byteLen32);
        	  
        	      iWriteLength =  byteLen32 + 4;
	              if( (iLengthWritten = write(sockfd, wbuf, iWriteLength)) != iWriteLength) // 512 byte expected
	                err_sys("write returned %d, expected %d", iLengthWritten, iWriteLength);
	              DBG_PRN("wrote %d bytes\n", iLengthWritten);
      	  
	              if (pauserw)
	                sleep(pauserw);
	            }
	          break;
  	        
            case BOARD_SELECT_ANSWER:  // client selected board
	            usBoard = (unsigned short)inBuffer[4];
              if( (sRet = DevInitBoard ( usBoard)) != DRV_NO_ERROR) {
	              DBG_PRN("board %d: DevInitBoard() error: %d \n", usBoard, sRet);
	            } else {
                DBG_PRN("board %d initialized\n", usBoard);
              }
	          break;
  	        
            default:
              /* unkonwn board number */
	            DBG_PRN("recved %d bytes: %.2X%.2X%.2X%.2X%.2X ...\n", iBytesReceived, inBuffer[0], inBuffer[1], inBuffer[2], inBuffer[3], inBuffer[4]);
	            break;
          }
          iBytesReceived = 0;  // in case of ODM msg we're done
				} else { // this is the bare RCS message
          /* NEW: Check if we have at least a complete message in the buffer */
          if( iBytesReceived < 8) {
            /* This is an incomplete message */
            DBG_PRN( "Error, incomplete RCS message received! Only a part of the msg header is available. Board %d, part_len %d\n", usBoard, iBytesReceived);
            iMsgPartLen = iBytesReceived; // this is the lengths of the available msg. part, will be continued in the netx read...
						iBytesReceived = 0; /* We finish this scan */
						memcpy( &abContiguousMsgBuffer[0], &inBuffer[0], iMsgPartLen);
					} else { /* at least a msg. header is available */
            MSG_STRUC* ptInMsg = (MSG_STRUC*)&inBuffer[0];
						memcpy((unsigned char*)&tMessage, ptInMsg, ptInMsg->ln + 8);
						if( iBytesReceived >= ptInMsg->ln + 8) {
							if( (sRet = DevPutMessage( usBoard, &tMessage, 2000L)) != DRV_NO_ERROR) { 
								DBG_PRN( "Error by driver function DevPutMessage(). (Error: %d), Board %d\n", sRet, usBoard);
							} else {  /* get response message from board */
								memset( (unsigned char*)&tMessage, 0, sizeof( tMessage));
								if( (sRet = DevGetMessage( usBoard, sizeof( tMessage), &tMessage, 10000L)) != DRV_NO_ERROR) {
									DBG_PRN( "Error by driver function DevGetMessage(). (Error: %d)\n", sRet);
								} else { // there is message for the client, send it over tcp/ip socket
									DBG_PRN( "tMessage(Get): %.2X-%.2X-%.2X-%.2X-%.2X-%.2X-%.2X-%.2X-%.2X\n", tMessage.rx, 
																																														tMessage.tx, 
																																														tMessage.ln, 
																																														tMessage.nr,
																																														tMessage.a,
																																														tMessage.f,  
																																														tMessage.b,  
																																														tMessage.e,  
																																														tMessage.data[0]);
									iWriteLength = tMessage.ln + 8;                                            
									if( (iLengthWritten = write( sockfd, (unsigned char*)&tMessage, iWriteLength)) != iWriteLength ) {
										err_sys("Error returning answer message via TCP/IP, socket write returns %d bytes, expected %d\n", iLengthWritten, iWriteLength);
									}
								}
							} 
	            
							/* NEW: Calculate the size of data which may be left in the buffer */
							iBytesReceived = iBytesReceived - (ptInMsg->ln + 8);
							if( iBytesReceived < 0)
								iBytesReceived = 0;                       // We have processed all bytes
							else
								inBuffer = &inBuffer[ptInMsg->ln + 8];    // Move forward in the buffer
						} else { /* a msg. header and a part of the msg itself is available */ 
							/* This is an incomplete message */
							DBG_PRN( "Error, incomplete RCS message received! A msg. header and a part of the msg itself is available. Board %d, msg.len %d, part_len %d\n", usBoard, tMessage.ln, iBytesReceived);
							iMsgPartLen = iBytesReceived; // this is the lengths of the available msg. part, will be continued in the netx read...
							iBytesReceived = 0; /* We finish this scan */
							memcpy( &abContiguousMsgBuffer[0], &inBuffer[0], iMsgPartLen);
						}
          } /* else { 'this is the bare RCS message' } */
        }
      } /* NEW: end while ( n > 0)*/
    }
    if( pauserw)
      sleep( pauserw);
  }
  
  if( pauseclose) {
    DBG_PRN( "pausing before close\n");
    sleep( pauseclose);
  }
  
  if( close( sockfd) < 0)
    err_sys( "close error");		/* since SO_LINGER may be set */
}
